package com.mjitech;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import org.apache.commons.collections4.CollectionUtils;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.CookieStore;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.cookie.Cookie;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.BasicCookieStore;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;

import com.alibaba.fastjson.JSONObject;

public class Test {

	public static void main(String[] args) {
		CookieStore cookieStore = new BasicCookieStore();
		String loginUrl = "https://www.mjitech.com/web/login.action";
		CloseableHttpClient client = HttpClients.custom()
				.setDefaultCookieStore(cookieStore).build();
		HttpPost httpPost = new HttpPost(loginUrl);
		JSONObject jsonParam = new JSONObject();
//		jsonParam.put("username", "zhangzhi@mjitech.com");
//		jsonParam.put("password", "admin");
		jsonParam.put("username", "gangwang@mjitech.com");
		jsonParam.put("password", "yier34wu6");
		StringEntity entity = new StringEntity(jsonParam.toString(), "utf-8");
		entity.setContentEncoding("UTF-8");
		entity.setContentType("application/json");

		try {
			httpPost.setEntity(entity);
			HttpResponse httpResponse = client.execute(httpPost);
			String responseString = EntityUtils.toString(httpResponse.getEntity());
			// System.out.println(responseString);
			if (httpResponse.getStatusLine().getStatusCode() == 200) {
				List<Cookie> cookies = cookieStore.getCookies();
				if (CollectionUtils.isNotEmpty(cookies)) {
					for (Cookie cookie : cookies) {
						System.out.println(cookie.getName() + ":" + cookie.getValue());
					}
				}
			}
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				// 关闭流并释放资源
				client.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

	}

	public static List<NameValuePair> getParam(Map<String, String> parameterMap) {
		List<NameValuePair> param = new ArrayList<NameValuePair>();
		Iterator<Entry<String, String>> it = parameterMap.entrySet().iterator();
		while (it.hasNext()) {
			Entry<String, String> parmEntry = it.next();
			param.add(new BasicNameValuePair((String) parmEntry.getKey(),
					(String) parmEntry.getValue()));
		}
		return param;
	}

}
